package org.openqa.selenium.devtools.v85.audits.model;

import org.openqa.selenium.Beta;
import org.openqa.selenium.json.JsonInput;

/**
 * This struct holds a list of optional fields with additional information
 * specific to the kind of issue. When adding a new issue code, please also
 * add a new optional field to this type.
 */
public class InspectorIssueDetails {

    private final java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.SameSiteCookieIssueDetails> sameSiteCookieIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.MixedContentIssueDetails> mixedContentIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.BlockedByResponseIssueDetails> blockedByResponseIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.HeavyAdIssueDetails> heavyAdIssueDetails;

    public InspectorIssueDetails(java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.SameSiteCookieIssueDetails> sameSiteCookieIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.MixedContentIssueDetails> mixedContentIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.BlockedByResponseIssueDetails> blockedByResponseIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.HeavyAdIssueDetails> heavyAdIssueDetails) {
        this.sameSiteCookieIssueDetails = sameSiteCookieIssueDetails;
        this.mixedContentIssueDetails = mixedContentIssueDetails;
        this.blockedByResponseIssueDetails = blockedByResponseIssueDetails;
        this.heavyAdIssueDetails = heavyAdIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.SameSiteCookieIssueDetails> getSameSiteCookieIssueDetails() {
        return sameSiteCookieIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.MixedContentIssueDetails> getMixedContentIssueDetails() {
        return mixedContentIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.BlockedByResponseIssueDetails> getBlockedByResponseIssueDetails() {
        return blockedByResponseIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.HeavyAdIssueDetails> getHeavyAdIssueDetails() {
        return heavyAdIssueDetails;
    }

    private static InspectorIssueDetails fromJson(JsonInput input) {
        java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.SameSiteCookieIssueDetails> sameSiteCookieIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.MixedContentIssueDetails> mixedContentIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.BlockedByResponseIssueDetails> blockedByResponseIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v85.audits.model.HeavyAdIssueDetails> heavyAdIssueDetails = java.util.Optional.empty();
        input.beginObject();
        while (input.hasNext()) {
            switch(input.nextName()) {
                case "sameSiteCookieIssueDetails":
                    sameSiteCookieIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v85.audits.model.SameSiteCookieIssueDetails.class));
                    break;
                case "mixedContentIssueDetails":
                    mixedContentIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v85.audits.model.MixedContentIssueDetails.class));
                    break;
                case "blockedByResponseIssueDetails":
                    blockedByResponseIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v85.audits.model.BlockedByResponseIssueDetails.class));
                    break;
                case "heavyAdIssueDetails":
                    heavyAdIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v85.audits.model.HeavyAdIssueDetails.class));
                    break;
                default:
                    input.skipValue();
                    break;
            }
        }
        input.endObject();
        return new InspectorIssueDetails(sameSiteCookieIssueDetails, mixedContentIssueDetails, blockedByResponseIssueDetails, heavyAdIssueDetails);
    }
}
